#!/bin/ksh
#> This script will upgrade to Tektronix 1.0.4.0.1
#

########################################################
# set paths and files

RELEASE="1.0.4.0.1"    
SourceDir="${FLEXPM_HOME}/patches/${RELEASE}"

ARCHIVE_DIR=$SourceDir/Archive
BACKUP_DIR=$SourceDir/Backup

########################################################


# Check env settings
 echo "Checking environment....."

  if ! [[ -d ${FLEXPM_HOME} ]]; then
     echo "Env variable FLEXPM_HOME must be set to appropriate dir before installation."
     exit;
  fi

  if ! [[ -d ${FLEXPM_BASE} ]]; then
     echo "Env variable FLEXPM_BASE must be set to appropriate dir before installation."
     exit;
  fi

  if ! [[ -d ${TekUTRAN_HOME} ]] ; then
    echo "Env variable TekUTRAN_HOME must be set to appropriate dir before installation."
    exit;
  fi

  if [[ ${TekUTRAN_HOME} != ${NE_BASE}/TekUTRAN ]]; then
    echo "Environment variable TekUTRAN_HOME might not be set as expected, please contact IBM Customer Support before proceeding installation."
    exit 2;
    fi
  
  if [ -z ${DB_CONNECT} ]; then
     echo "Env variable DB_CONNECT must be set to approriate database connection values."
     exit 1;
  fi

  echo "+ Installing HotFix.... "

    echo "+ Backing up original files and installing new files..."

    mkdir -p ${BACKUP_DIR}
    mkdir -p ${ARCHIVE_DIR}

echo ""
echo "+ Backing up original Tektronix UTRAN module files ..."
cd $TekUTRAN_HOME
for file in `gunzip -c ${SourceDir}/TekUTRAN_1.0.tgz | tar tf -`
do
  if [ -f $file ]
  then
    if [ ! -d ${ARCHIVE_DIR}/`dirname $file` ]
    then
      mkdir -p ${ARCHIVE_DIR}/`dirname $file`
    fi
    cp -p $file ${ARCHIVE_DIR}/`dirname $file`
    chmod +w $file
  fi
done

cd $SourceDir/Archive
tar cf - * | gzip -c > ../Module_Archive_`date '+%y%m%d_%H%M%S'`.tar.gz
cd $SourceDir
rm -rf ${ARCHIVE_DIR}
mv -f Module_Archive*.tar.gz $BACKUP_DIR/

cd $TekUTRAN_HOME

echo "+ Installing updated files for TekUTRAN module ..."

gunzip -c ${SourceDir}/TekUTRAN_1.0.tgz | tar xf -

    cd $PM_HOME/peik/xml
    touch parser.err
    chmod 777 parser.err

    echo "### running dict_update ###"

    cd $TekUTRAN_HOME/peik
    make dict_update_MSC

    echo "### complete dict_update ###"

  echo "Executing iz22343.sql script"
  echo "@${SourceDir}/iz22343.sql" | sqlplus -s $DB_CONNECT
  echo ""
   
  echo "+ Done for TekUTRAN module ..."
  echo "" 
