---
--- Script to disable the trigger TEK_ENT_MSC_BIU
---

ALTER TRIGGER TEK_ENT_MSC_BIU DISABLE;

---
--- Update Legacy Data from RNC_ID field to MSC_ID field
---
 
UPDATE TEK_ENT_MSC
SET MSC_ID = RNC_ID
WHERE RNC_ID is NOT NULL;

COMMIT;

---
---
---

UPDATE TEK_ENT_MSC
SET RNC_ID = ''
WHERE MSC_ID is NOT NULL;

COMMIT;

---
--- Enable the trigger TEK_ENT_MSC_BIU
---

ALTER TRIGGER TEK_ENT_MSC_BIU ENABLE;

---
--- Recreate the trigger with new definition
---

CREATE or REPLACE TRIGGER TEK_ENT_MSC_BIU 
    BEFORE INSERT OR UPDATE ON TEK_ENT_MSC 
    FOR EACH ROW
DECLARE  
  vFullKey   wmn_Instance_Context.FullKey%TYPE;
  vEnd       INTEGER;  
BEGIN  
   IF INSERTING THEN  
    IF :new.UpdateCount IS NULL THEN   
            :new.UpdateCount := 1;
    END IF;
     SELECT FullKey INTO vFullKey 
     FROM wmn_Instance_Context   
     WHERE Context_ID = wm_Scenario.Get_Context 
     AND Instance_ID = :new.Instance_ID;  
     
	vEnd := INSTR( vFullKey || '-','-' ); 
     	:new.SYSTEM_id :=SUBSTR( vFullKey, 1, vEnd - 1 ); 
     	vFullKey := SUBSTR( vFullKey, vEnd + 1 );  
     	vEnd := INSTR( vFullKey ||'-','-' );  
     	:new.MSC_ID :=SUBSTR( vFullKey, 1, vEnd - 1 );  
   ELSIF UPDATING THEN    
    IF :new.UpdateCount IS NULL THEN   
       :new.UpdateCount := :old.UpdateCount + 1;   
    ELSIF :new.UpdateCount < :old.UpdateCount THEN    
       :new.UpdateCount := :old.UpdateCount;    
    END IF;   
   END IF;   
   wm_Alert.Signal('MSC'); 
END;
/
EXIT
/
